#include <sys/ioctl.h>
#include <stdio.h>
#include <termios.h>

#include "sim.h"

void win_end(void);
void win_init(Window* w);
void win_query(Window* w);

static struct termios initial_state;

void
win_end(void)
{
	printf(ED CSI "H");
	tcsetattr(0, TCSAFLUSH, &initial_state);
}

void
win_init(Window* w)
{
	struct termios raw_state;

	tcgetattr(0, &initial_state);
	raw_state = initial_state;
	raw_state.c_lflag &= ~(ECHO|ICANON|ISIG);
	tcsetattr(0, TCSAFLUSH, &raw_state);
	setbuf(stdout, NULL);
	printf(CSI "H\t" CSI "6n");
	scanf("\x1b[%*d;%huR", &w->t);
	--w->t;
}

void
win_query(Window* w)
{
	struct winsize ws;

	ioctl(0, TIOCGWINSZ, &ws);
	w->wx = ws.ws_col;
	w->wy = ws.ws_row;
}
